document.onkeypress = keyPress;
document.onkeyup = keyUp;
document.onkeydown = keyDown;

var updateFrequencyOptions = [];

if (lng == "fr") {
	updateFrequencyOptions = [{
		value: -1,
		text: "Jamais"
	}, {
		value: (1000 * 60 * 5),
		text: "toutes les 5 min"
	}, {
		value: (1000 * 60 * 15),
		text: "toutes les 15 min"
	}, {
		value: (1000 * 60 * 60),
		text: "toutes les 60 min"
	}, ];
}else{
		updateFrequencyOptions = [{
		value: -1,
		text: "Never"
	}, {
		value: (1000 * 60 * 5),
		text: "5 min"
	}, {
		value: (1000 * 60 * 15),
		text: "15 min"
	}, {
		value: (1000 * 60 * 60),
		text: "60 min"
	}, ];
}


var feedUpdateBroker = null;
var currentnews = null;
var currentnews_key = 0;
var selected_news = false;
var feedItemControls = [];
var items = [];
var currentnewsw = 0;
var feedItemControlPool = [];
var feedLastModified = null;
var feedUpdateCommanded = false;
var uiManager;
var mainView;
var settingsView;
var colortheme = "";
var feedNameText;
var feedUrlText;
var feedSelection;
var feedUpdateFrequencySelection;
var settingsSaveButton;
var settingsCancelButton;
var fullsize = 0;
var MENU_ITEM_SETTINGS = 0;
var MENU_ITEM_REFRESH = 1;
var MENU_ITEM_ABOUT = 2;
var updateTimerId = null;
var aboutLabel;
var feedUpdateFrequency = -1;
var feedUpdateTime = -1;



function setViewMode(){

   var isInHSView = isHSViewMode();
   if ( isInHSView ) {
      	fullsize = 0;
		  
	 } else {
		fullsize = 1;
   }
}
function isHSViewMode() {
	var size = Helper.getScreenSize();
	return ( size.height < 150);
	
}

widget.setNavigationEnabled(false);
	  
function keyPress(event) {
	event.charCode;
	if(event.keyCode == 13) {
		
		if(selected_news==false){
			if(currentnews_key == 0) {
				showitem(0);
			}else{
				showitem(currentnews_key);
			}
			selected_news = true;
		}else{
			closecontent(currentnews_key);
			selected_news = false;
		}
	
	
	}
}
      
function keyDown(event) {
	
	if(event.keyCode == 40 && selected_news==false){

		if(currentnews_key < items.length-1){
			currentnews_key++;				
		} else{
			currentnews_key = 0;
		}
	}
	
	for(k=0; k<items.length; k++) {
			if(k == currentnews_key){ 
				document.getElementById("lignerss"+k).style.display='inline';
			}else{
				document.getElementById("lignerss"+k).style.display='none';
			}
	}	
	event.charCode;
}
			
function keyUp(event) {
	
	if(event.keyCode == 38 && selected_news==false){
		if((currentnews_key <items.length) && (currentnews_key > 0)){
			currentnews_key--;
		} else{
			currentnews_key = 0;
		}
	}
	
	for(k=0; k<items.length; k++) {
			if(k == currentnews_key){ 
				document.getElementById("lignerss"+k).style.display='inline';
			}else{
				document.getElementById("lignerss"+k).style.display='none';
			}
	}	
	event.charCode;	
}


function init() {
	
	setViewMode();

    if (window.widget) {
        // set tab-navigation mode and show softkeys
        widget.setNavigationEnabled(false);
        window.menu.showSoftkeys();
        
        // create menu
		if (lng == 'fr') {
			menureg="Réglages";
			menuref="Rafraichir";
			menuab = "A propos de ";
		}else{
			menureg="Settings";
			menuref="Refresh";
			menuab = "About";			
		}
        var settingsMenuItem = new MenuItem(menureg, MENU_ITEM_SETTINGS);
        settingsMenuItem.onSelect = menuItemSelected;
        menu.append(settingsMenuItem);
        var refreshMenuItem = new MenuItem(menuref, MENU_ITEM_REFRESH);
        refreshMenuItem.onSelect = menuItemSelected;
        menu.append(refreshMenuItem);
		var aboutMenuItem = new MenuItem(menuab, MENU_ITEM_ABOUT);
		aboutMenuItem.onSelect = menuItemSelected;
		menu.append(aboutMenuItem);
    }
    
	loadPreferences();

    uiManager = new UIManager();
    mainView = new ListView();
    settingsView = new ListView();
	
	if(lng == "fr"){
    	settingsSaveButton = new FormButton(null, "Sauvegarder");
	}else{
	 	settingsSaveButton = new FormButton(null, "Save");	
	}
	
    settingsSaveButton.addEventListener("ActionPerformed", saveSettingsClicked);
    settingsView.addControl(settingsSaveButton);
	if (lng == "fr") {
		settingsCancelButton = new FormButton(null, "Annuler");
	}else{
		settingsCancelButton = new FormButton(null, "Cancel");		
	}
    settingsCancelButton.addEventListener("ActionPerformed", showMainView);
    settingsView.addControl(settingsCancelButton);
    

	if (feedURL != null) {
        showMainView();
        updateFeed();
    } else {
        showSettings();
    }

    updateTimerId = setInterval(updateFeedTimerFunc, 1000);
	showMain();
}

function menuItemSelected(id) {
    switch (id) {
        case MENU_ITEM_SETTINGS:
            showSettings();
            break;
        case MENU_ITEM_REFRESH:
            updateFeed();
            break;
		case MENU_ITEM_ABOUT:
			showAboutView();
			break;
    }
}

function loadPreferences() {
    if (window.widget) {
		var feedUpdateFrequencyStr = widget.preferenceForKey("FeedUpdateFrequency");
		feedUpdateFrequency = (feedUpdateFrequencyStr == null) ? -1 : parseInt(feedUpdateFrequencyStr);
		
		var colorthemeStr = widget.preferenceForKey("colortheme");
		colortheme = (colorthemeStr == null) ? "" : colorthemeStr;
    }
}

function savePreferences() {

    if (window.widget) {
        widget.setPreferenceForKey(feedUpdateFrequency.toString(), "FeedUpdateFrequency");
		 widget.setPreferenceForKey(colortheme.toString(), "colortheme");
    }
}

function saveSettingsClicked() {
	len = document.f1.feedUpdateFrequencySelection.length;
	for (i = 0; i <len; i++) {
		if (document.f1.feedUpdateFrequencySelection[i].checked) {
		chosen = document.f1.feedUpdateFrequencySelection[i].value;
		}
	}

    var selectedFrequency = chosen;
    feedUpdateFrequency = (selectedFrequency != null) ? selectedFrequency : -1;

	
	
	len = document.f1.colortheme.length;
	for (i = 0; i <len; i++) {
		if (document.f1.colortheme[i].checked) {
		chosen = document.f1.colortheme[i].value;
		}
	}

    var colorthemeStr = chosen;
    colortheme = (colorthemeStr != null) ? colorthemeStr : -1;

    savePreferences();
    
    showMain();
}

// Show main view.
function showMainView() {
    var mainViewCaption = (feedName == null) ? null : feedName;
	document.getElementById("title_txt").innerHTML = mainViewCaption;
    if (window.widget) {
        menu.setRightSoftkeyLabel("", null);
    }
}

function showSettings() {
   	var OUT;
	document.getElementById("content").style.display='none';
	document.getElementById("settings").style.display='inline';
	if(currentnews != null){
		document.getElementById("detail"+currentnews).style.display='none';
		currentnews = null;
	
	} 
	if (lng == "fr") {
		OUT = "<b>Fréquence de mise à jour</b><br>";
	}else{
		OUT = "<b>update frequency</b><br>";
	}
	OUT += "<form name='f1'><ul style='list-style-type:none;'>";
	for(var i = 0; i < updateFrequencyOptions.length; i++){
			var checked = '';

			if(	feedUpdateFrequency == updateFrequencyOptions[i].value) {
				checked = 'checked=true';
			}
			
			OUT += "<li><input type='radio' "+checked+" name='feedUpdateFrequencySelection' value='"+updateFrequencyOptions[i].value+"'>"+updateFrequencyOptions[i].text+"</li>";		
		
	}
	
	
	var checkedd = "";
	var checkedb = "";
	var checkedg = "";
	var checkedgr = "";
	var checkedo = "";
	var checkedp = "";
	var checkedr = "";

	
	if(colortheme=='') checked = 'checked=true';	
	if(colortheme=='B') checkedd = 'checked=true';
	if(colortheme=='G') checkedb = 'checked=true';
	if(colortheme=='G') checkedg = 'checked=true';
	if(colortheme=='Gr') checkedgr = 'checked=true';
	if(colortheme=='O') checkedo = 'checked=true';
	if(colortheme=='P') checkedp = 'checked=true';
	if(colortheme=='R') checkedr = 'checked=true';


	if (lng == "fr") {
		OUT += "</ul><br><b>Choix du théme</b><br><ul style='list-style-type:none;'>";
		OUT += "<li><input type='radio' " + checked + " name='colortheme' value=''>Turquois</li>";
		OUT += "<li><input type='radio' " + checkedb + " name='colortheme' value='B'>Bleu</li>";
		OUT += "<li><input type='radio' " + checkedg + " name='colortheme' value='G'>Vert</li>";
		OUT += "<li><input type='radio' " + checkedgr + " name='colortheme' value='Gr'>Gris</li>";
		OUT += "<li><input type='radio' " + checkedo + " name='colortheme' value='O'>Orange</li>";
		OUT += "<li><input type='radio' " + checkedp + " name='colortheme' value='P'>Violet</li>";
		OUT += "<li><input type='radio' " + checkedr + " name='colortheme' value='R'>Rouge</li>";
		tmpsave = 'SAUVEGARDER';
		tmpcancel = 'ANNULER';

	}else{
		
		OUT += "</ul><br><b>Skin template</b><br><ul style='list-style-type:none;'>";
		OUT += "<li><input type='radio' " + checked + " name='colortheme' value=''>Light blue</li>";
		OUT += "<li><input type='radio' " + checkedb + " name='colortheme' value='B'>Blue</li>";
		OUT += "<li><input type='radio' " + checkedg + " name='colortheme' value='G'>Green</li>";
		OUT += "<li><input type='radio' " + checkedgr + " name='colortheme' value='Gr'>Gray</li>";
		OUT += "<li><input type='radio' " + checkedo + " name='colortheme' value='O'>Orange</li>";
		OUT += "<li><input type='radio' " + checkedp + " name='colortheme' value='P'>Purple</li>";
		OUT += "<li><input type='radio' " + checkedr + " name='colortheme' value='R'>Red</li>";
		tmpsave = 'SAVE';
		tmpcancel = 'CANCEL';
	}
	
	OUT += "</ul>";
	
	OUT += "<br><input type='button' style='width:150px;height:40px' align=center onClick='javascript:saveSettingsClicked();' value='"+tmpsave+"'>&nbsp;";
	OUT += "<input type='button' style='width:150px;height:40px' align=center  onClick='javascript:showMain();' value='"+tmpcancel+"'>";
	
	OUT += "</form>";
	document.getElementById("settings").innerHTML = OUT;

}

//Displays the About view
function showAboutView(){
	var OUT;
	document.getElementById("content").style.display='none';
	document.getElementById("settings").style.display='inline';
	if(currentnews != null){
		document.getElementById("detail"+currentnews).style.display='none';
		currentnews = null;
	
	}
	if (lng == 'fr') {
		OUT = "<p><b>A propos de ...</b><br><br><p align=center>Développé par Tarik ALAOUI (<a href='javascript:openURL(\"http://www.alaoui.me\")'>www.alaoui.me</a>)";
		OUT += "<br><a href='javascript:openURL(\"http://www.alaoui.me\")'><img align=center src='images/logo_perso_small.png' border=0></a><br><br><p align=center><input type='button'  style='width:200px;height:50px' onClick='javascript:showMain();' value='Fermer'></p></p></p>";
	}else{
		OUT = "<p><b>About...</b><br><br><p align=center>This application is developped by Tarik ALAOUI (<a href='javascript:openURL(\"http://www.alaoui.me\")'>www.alaoui.me</a>)";
		OUT += "<br><a href='javascript:openURL(\"http://www.alaoui.me\")'><img align=center src='images/logo_perso_small.png' border=0></a><br><br><p align=center><input type='button'  style='width:200px;height:50px' onClick='javascript:showMain();' value='Close'></p></p></p>";

		
	}		
	document.getElementById("settings").innerHTML = OUT;
	menu.setRightSoftkeyLabel("ok", showMain);
}

// Sets the softkeys for about view.
function setAboutViewSoftkeys() {
    if (window.widget) {
        // set right softkey to "Ok" (returns to main view)
        menu.setRightSoftkeyLabel("Ok", showMainView);
    }
}

// Schedules an immediate feed update.
function updateFeed() {
    feedUpdateTime = 0;
    feedUpdateCommanded = true;
	document.getElementById("content").style.display='inline';
	document.getElementById("settings").style.display='none';
	if(currentnews != null){
		closecontent(currentnews);
	}
}

function showMain(){
	setViewMode();
		
	if (fullsize == 1) {
		//newImage = "url(images/fullscreen_01"+colortheme+".jpg)";
		//document.getElementById("title").style.backgroundImage = newImage;

		newImage = "url(images/pix"+colortheme+".png)";
		document.getElementById("header").style.backgroundImage = newImage;
		
		
		newImagew = "url(images/widget_01"+colortheme+".png)";
		document.getElementById("headerw").style.backgroundImage = newImagew;

		document.getElementById("content").style.display = 'inline';
		document.getElementById("settings").style.display = 'none';
		document.getElementById("widgetview").style.display = 'none';
		document.getElementById("fullscreen").style.display = 'inline';
		
		if (currentnews != null) {
			closecontent(currentnews);
		}
	}else{
		document.getElementById("widgetview").style.display = 'inline';
		document.getElementById("fullscreen").style.display = 'none';
	}

	if (fullsize == 1) {
		setFeedItems(items);
	}else{
		setFeedItemsWidget();
	}
	menu.setRightSoftkeyLabel("", null);	
}

// Timer function for feed updates - called once every second.
function updateFeedTimerFunc() {
    var now = new Date().getTime();
    
    // check if a feed update has been scheduled, if it's time to update now,
    // and if there's no update currently in progress and if we're in the main view

	if ((feedURL != null) &&
                (feedUpdateTime != -1) &&
                (now > feedUpdateTime)) {
        // show progress dialog if this is a commanded feed update
        if (feedUpdateCommanded) {
            // no auto hiding, wait-type notification, unknown progress
            uiManager.showNotification(-1, "wait", "Loading feed...", -1);
        }
        
        // fetch the feed from the specified URL
        feedUpdateBroker = new FeedUpdateBroker();
        feedUpdateBroker.fetchFeed(feedURL, feedUpdateCompleted);
        
        if (feedUpdateFrequency != -1) {
            // schedule next update
            feedUpdateTime = now + feedUpdateFrequency;
        } else {
            // feed update frequency is "never"
            feedUpdateTime = -1;
        }
    }
}

// Callback function that gets called when a feed update has completed.
function feedUpdateCompleted(event) {
    if (event.status == "ok") {
        // if there aren't any feed items yet, we'll hide the progress dialog
        if (feedUpdateCommanded) {
            uiManager.hideNotification();
        }
        
        // check if the feed has updated
        if (event.lastModified != feedLastModified) {
            // remember the last modified timestamp
            feedLastModified = event.lastModified;
            
            // feed fetched and parsed successfully
			items = event.items;
            if (fullsize == 1) {
				setFeedItems(items);
			}else{
				setFeedItemsWidget();				
			}
            // focus the first feed item control
            // (but only if we are in the main view)
            if (uiManager.getView() == mainView) {
                feedItemControls[0].setFocused(true);
            }
        }
    } else {
        // show error message
        uiManager.showNotification(3000, "warning", "Error while updating feed!<br/>(check network settings)");
    }
    
    // null the broker reference to indicate that there's no current
    // update in progress
    feedUpdateBroker = null;
    
    // reset commanded feed update flag
    feedUpdateCommanded = false;
}

// Removes feed items.
function removeFeedItems() {
    // remove all current feed items from the main view
    for (var i = 0; i < feedItemControls.length; i++) {
        mainView.removeControl(feedItemControls[i]);
    }
    
    // reset feed item control array
    feedItemControls = [];
}

// Sets feed items.
function setFeedItems(items) {
    // start by removing all current feed items
    removeFeedItems();
    var OUT = "<table>";
	var OUTD = "<table>";
	
    // create new feed items and add them to the main view
    // use feed item pool to recycle controls
    for (var i = 0; i < items.length; i++) {
        var item = items[i];
		OUT += "<tr><td><img src='images/arrow.png' border=0 id='lignerss"+i+"' style='display:none'>&nbsp;<a href='#top' onClick='javascript:showitem("+i+");'>"+item.title+"</a></td></tr>";

		OUTD+="<tr><td><div id='detail"+i+"' style=\"display:none\" class=\"detail\">";
		OUTD+="<table width=100% cellspacing=0 cellpadding=0 border=0><tr><td style='background-color:#ffffff' align=left width=40px><a href=\"javascript:closecontent("+i+")\"><img src='images/back.png' style='margin-left:-10px;border:0px' border=0></a></td>";
		OUTD+="<td style='background-color:#ffffff'><span id='titlenews'>"+item.title+"<br><span align=right><font size=2 color=#003366>"+formatdate(item.date)+"</font></span></span></td></tr></table>";
		OUTD+="<div id='contentnews'>";
		if (item.description != null) {
			OUTD += item.description + "<br><br>";
		}
		if (lng == "fr") {
		OUTD+="<a href='javascript:openURL(\""+item.url+"\")'>Lire la suite</a><br><br></div></div></td></tr>";
		}else{
		OUTD+="<a href='javascript:openURL(\""+item.url+"\")'>Read all the article</a><br><br></div></div></td></tr>";		
		}
    }
	
	OUT += "</table>";
	OUTD += "</table>";
	document.getElementById("listnews").innerHTML = OUT;
	document.getElementById("contentdesc").innerHTML = OUTD;
	document.getElementById("lignerss0").style.display='inline';	
}
function formatdate(date){
	var tmp = date.split(',');
	if(tmp.length > 1) {
		tmp = date.split(' ');
		return tmp[1]+" "+tmp[2]+" " +tmp[3] + " "+tmp[4];
	}else{
		return date;
	}
}
function setFeedItemsWidget() {
	slidenews();
}

function showitem(id){
	currentnews = id;
	document.getElementById("content").style.display='none';	
	document.getElementById("contentdesc").style.display = 'inline';
	document.getElementById("detail"+id).style.display='inline';		
		
	for(k=0;k<items.length;k++) document.getElementById("lignerss"+k).style.display='none';	
	document.getElementById("lignerss"+id).style.display='inline';	
	document.getElementById("lignerss"+id).style.display='inline';	
}

function closecontent(id){
	currentnews = null;
	document.getElementById("content").style.display='inline';	
	document.getElementById("contentdesc").style.display = 'none';	
	document.getElementById("detail"+id).style.display='none';	
}

var timewidet = -1;

function slidenews(){

	if(items.length > 0) {
		 var item = items[0];
		document.getElementById("news").innerHTML = feedName+ " : " +item.title;
		}else{
		document.getElementById("news").innerHTML = feedName+" : Aucune donnée";
		}

}
	
// Opens a URL.
function openURL(url) {
    if (window.widget) {
        // in WRT
        widget.openURL(url);
    } else {
        // outside WRT
        window.open(url, "NewWindow");
    }
}
